local jkCiderProduction = ...

jkCiderProduction:registerAssetId("models/tree/apple_tree.fbx/Prefab/TreePart", MOD_NS .. "PREFAB_APPLE_TREE")
jkCiderProduction:registerAssetProcessor("models/tree/apple_tree.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

jkCiderProduction:registerAssetId("models/tree/branch_z_0.png", MOD_NS .. "BRANCH_Z_0")
jkCiderProduction:registerAssetId("models/tree/branch_z_01.png", MOD_NS .. "BRANCH_Z_01")
jkCiderProduction:registerAssetId("models/tree/branch_z_02.png", MOD_NS .. "BRANCH_Z_02")
jkCiderProduction:registerAssetId("models/tree/branch_z_03.png", MOD_NS .. "BRANCH_Z_03")
jkCiderProduction:registerAssetId("models/tree/branch_z_04.png", MOD_NS .. "BRANCH_Z_04")

jkCiderProduction:registerAssetId("models/tree/apple_tree.fbx/Materials/leaves_material", MOD_NS .. "NO_LEAVES_MATERIAL")
jkCiderProduction:registerAssetId("models/tree/apple_tree.fbx/Materials/Z_leaves_material_4", MOD_NS .. "LEAVES_AND_APPLES_MATERIAL")
jkCiderProduction:registerAssetId("models/tree/apple_tree.fbx/Materials/Z_leaves_material_1", MOD_NS .. "Z_LEAVES_MATERIAL_1")
jkCiderProduction:registerAssetId("models/tree/apple_tree.fbx/Materials/Z_leaves_material_2", MOD_NS .. "Z_LEAVES_MATERIAL_2")
jkCiderProduction:registerAssetId("models/tree/apple_tree.fbx/Materials/Z_leaves_material_3", MOD_NS .. "Z_LEAVES_MATERIAL_3")
jkCiderProduction:override({
    Id = MOD_NS .. "NO_LEAVES_MATERIAL",
    HasAlphaTest = true,
	BackFaceVisible = true,
	HasShadow = true,
    IsLighted = true,
    AlbedoTexture = MOD_NS .. "BRANCH_Z_0"
})

jkCiderProduction:override({
    Id = MOD_NS .. "LEAVES_AND_APPLES_MATERIAL",
    HasAlphaTest = true,
    BackFaceVisible = true,
	HasShadow = true,
    AlbedoTexture = MOD_NS .. "BRANCH_Z_04"
})

jkCiderProduction:override({
    Id = MOD_NS .. "Z_LEAVES_MATERIAL_1",
    HasAlphaTest = true,
    BackFaceVisible = true,
	HasShadow = true,
    AlbedoTexture = MOD_NS .. "BRANCH_Z_01"
})
jkCiderProduction:override({
    Id = MOD_NS .. "Z_LEAVES_MATERIAL_2",
    HasAlphaTest = true,
    BackFaceVisible = true,
	HasShadow = true,
    AlbedoTexture = MOD_NS .. "BRANCH_Z_02"
})
jkCiderProduction:override({
    Id = MOD_NS .. "Z_LEAVES_MATERIAL_3",
    HasAlphaTest = true,
    BackFaceVisible = true,
	HasShadow = true,
    AlbedoTexture = MOD_NS .. "BRANCH_Z_03"
})

jkCiderProduction:registerPrefabComponent("models/tree/apple_tree.fbx/Prefab/TreePart", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_FRUIT",
    IsReplenishable = true,
    ReplenishDurationInDays = 7,
    ReplenishQuantity = 1,
    IsDestroyWhenEmpty = false, 
    AvailableQuantity = 3,
    ResourceValue = 1,
    Radius = 1.5
})

jkCiderProduction:registerPrefabComponent("models/tree/apple_tree.fbx/Prefab/TreePart", { 
    DataType = "COMP_PLANTABLE", 
    MinSpaceBetweenPlant = 15.0 
})

jkCiderProduction:registerPrefabComponent("models/tree/apple_tree.fbx/Prefab/TreePart", { 
    DataType = MOD_NS .. "COMP_APPLE_TREE",
})

jkCiderProduction:register({
    DataType = "PLANTABLE",
    Id = MOD_NS .. "PLANTABLE_APPLE_TREE",
    Name = MOD_NS .. "PLANTABLE_APPLE_TREE_NAME",
    Icon = "ICON_FRUIT",
    PlantPrefab = MOD_NS .. "PREFAB_APPLE_TREE",
    MinimumScale = 0.85,
    MaximumScale = 1.1
})

jkCiderProduction:registerAssetId("icons/apple.png", MOD_NS .. "ICON_APPLE")
jkCiderProduction:registerAssetId("icons/cider.png", MOD_NS .. "ICON_CIDER")

jkCiderProduction:registerEnumValue( "RESOURCE_TYPE", "RESOURCE_TYPE_APPLE" )


-- reused RESOURCE_FRUIT from Common Resources mod
-- jkCiderProduction:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_APPLE",
-- 	ResourceName = "RESOURCE_APPLE_NAME",
-- 	Icon = MOD_NS .. "ICON_APPLE",
-- 	ResourceTypeList = { "FOOD", "RESOURCE_TYPE_APPLE", "GRANARY" },
-- 	IsTradable = true,
-- 	ResourceLayoutType = "CRATES",
-- 	VillagerBuyingPrice = { Resource = "GOLD", Quantity = 5 },
-- 	DisplayInInventory = true
-- })

-- reused the resource from Common Resources mod
-- jkCiderProduction:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_CIDER",
-- 	ResourceName = "RESOURCE_CIDER_NAME",
-- 	Icon = MOD_NS .. "ICON_CIDER",
-- 	ResourceTypeList = { "TAVERN" },
-- 	IsTradable = true,
-- 	ResourceLayoutType = "CRATES",
-- 	VillagerBuyingPrice = { Resource = "GOLD", Quantity = 15 },
-- 	DisplayInInventory = true
-- })

-- Crop Field Element -------------------------------------------------------------------------------------
jkCiderProduction:registerPrefabComponent("models/tree/apple_tree.fbx/Prefab/TreePart", { DataType = "COMP_CROP_FIELD_ELEMENT" })


-- Zone -------------------------------------------------------------------------------------
jkCiderProduction:register({
    DataType = "ZONE",
    Id = MOD_NS .. "ZONE_APPLE_FARM",
    Icon = "ICON_FRUIT",
    HoverIcon = "ICON_FRUIT",
    SelectionIcon = "ICON_FRUIT",
    Name = MOD_NS .. "ZONE_APPLE_FARM_NAME",
    Description = MOD_NS .. "ZONE_APPLE_FARM_DESC",
    Color = {1.8, 2.50, 1.70, 0.9},
    DesirabilityLayerToShow = "DESIRABILITY_FERTILITY"
})


-- Farm Field Config -------------------------------------------------------------------------------------
jkCiderProduction:register({
    DataType = "FARM_FIELD_CONFIG",
    Id = MOD_NS .."FARM_FIELD_CONFIG_APPLE_FARM",
    ZoneType = MOD_NS .."ZONE_APPLE_FARM",
    PlantPrefab = MOD_NS .."PREFAB_APPLE_TREE",
    HasPlantingCycle = false,
    IsScaling = true,
    RowDistance = 5.9,
    ItemDistance = 5.2,
    RandomOrientation = {0, 360},
    RandomPositionOffset = {-.5, .5},
    SourceMaterial = MOD_NS .. "NO_LEAVES_MATERIAL",
    GrowingMaterial = MOD_NS .. "LEAVES_AND_APPLES_MATERIAL",
    HarvestedMaterial = MOD_NS .. "NO_LEAVES_MATERIAL",
    GrowingTextureList = {
    },
    HarvestingTextureList = {
    },
    AlphaTestThreshold = 0.5
})

